/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginMagicDirectory = {};
pluginMagicDirectory.localization = {};
/****************************/

// Plugin details
var pluginName = "MagicDirectory";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginMagicDirectory.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	lblHelpTabText : "Help",
	lblSetupTabText : "Setup",
	lblAdvancedTabText : "Advanced",
	lblPathText : "Path : ",
	btnBrowseText : "Browse",
	lblTemplateUsernameText : "Template Username : ",
	lblOverwriteVFSItemsText : "Overwrite VFS items?",
	lblTemplateUsernameHelpText : " If you specify a template username, all settings from that user will be used including that users virtual file system. ",
	lblSeparatorText : "User / Pass Separator : ",
	lblDirectoryPermissionText : "Directory permissions : ",
	lblRemoveUnsafeCharsText : "Remove unsafe web characters?",
	lblQuotaIsForAllUsersText : "Quota is for all users",
	lblDirScanDepthText : "Directory scan depth : ",
	lblConvertRandomPassText : "Convert 'random' password to generated random password.",
	lblMD5HashText : "MD5 hash passwords.",
	lblUseExpirationDateText : "Use Expiration Date.",
	lblExpirationDateFormatText : "Expiration Date Format : ",
	lblDeleteText : "Delete?",
	lblUseEmailText : "Use Email",
	lblTranslateNotifyEmailsText : "Translate 'notify_' emails and send new account notification.",
	lblEmailSubjectText : "Email Subject : ",
	lblEmailFromAddressText : "Email From Address : ",
	lblEmailCCAddressText : "Email CC Address : ",
	lblEmailBCCAddressText : "Email BCC Address : ",
	lblEmailBodyText : "Email Body : "
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginMagicDirectory.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginMagicDirectory.init = function(pluginID, returnXML){
	pluginMagicDirectory.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginMagicDirectory.bindData(0, pluginID);
}

// Interface methods
pluginMagicDirectory.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginMagicDirectory.bindPluginDetails(curPlugin);
	}
	pluginMagicDirectory.bindEvents();
}

pluginMagicDirectory.bindEvents = function()
{
	if(this.eventAdded)return;
	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginMagicDirectory.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginMagicDirectory.returnXML, pluginName);
	});
	_plugin.find("a[rel='setup']").trigger("click");
	
	$("a.serverFilePickButton", _plugin).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _panel).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});
	this.eventAdded = true;
}

pluginMagicDirectory.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");
}

pluginMagicDirectory.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginMagicDirectory.returnXML)
	{
		if(!pluginMagicDirectory.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			inputs.addClass("ignoreBind");
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginMagicDirectory.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}