/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelRestrictions = {};
panelRestrictions.localization = {};
/****************************/

// Panel details
var panelName = "Restrictions";
var _panel = $("#pnl" + panelName);

// Localizations
panelRestrictions.localization = {
	headerText : " ",
	lblDaysOfTheWeeksAllowedToConnectHeaderText : " Days of the week users are allowed to connect: ",
	lblSundayText : "Sunday",
	lblMondayText : "Monday",
	lblTuesdayText : "Tuesday",
	lblWednesdayText : "Wednesday",
	lblThursdayText : "Thursday",
	lblFridayText : "Friday",
	lblSaturdayText : "Saturday",
	lblDownloadQueuingText : "Download Queuing?",
	lblDownloadQueueSizeLabelText : "Download Queue Size:",
	lblDownloadQueueSizeMaxLabelText : "Max:",
	lblUploadQueuingLabelText : "Upload Queuing?",
	lblUploadQueueSizeLabelText : "Upload Queue Size:",
	lblUploadQueueSizeMaxLabelText : "Max:",
	lblDenyFXPLabelText : "Deny FXP?",
	lblDenyLocalhostAdministrationLabelText : "Deny localhost automatic remote administration?",
	lblDenyReservedPortsLabelText : "Deny reserved ports?",
	lblFileNameFiltersLabelText : " Filename Filters (block matching names) ",
	btnAddNewFilenameFilterText : " Add",
	lblBlockPathMatchingPatternLabelText : " Block access to any path matching these patterns: ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelRestrictions.localization, localizations.panels[panelName]);

// Interface methods
panelRestrictions.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelRestrictions.localization.Header, true);
	panelRestrictions.bindData();
	panelRestrictions.bindEvents();
}

panelRestrictions.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	var daysAllowed = getTextValueFromXMLNode(prefs["day_of_week_allow"], "");
	for(var i=0; i< daysAllowed.toString().length;i++)
	{
		checkUnchekInput($("#day_of_week_allow_" + daysAllowed.charAt(i), _panel), true);
	}
}

panelRestrictions.bindEvents = function()
{
	$("a#addFilenameFilter", _panel).click(function(){
		var stopOption =  "";
		jPrompt("Choose one : ", stopOption, "Stop Options", function(value){
			stopOption = value;
			if(stopOption!=null)
			{
				if(stopOption.length == 0)
				{
					$("a#addFilenameFilter", _panel).trigger("click");
					return;
				}
				var textValue = "";
				jPrompt("Please enter the text :", textValue, "CrushFTP Filters!", function(value){
					textValue = value;
					$("#filename_filters_str", _panel).val($("#filename_filters_str", _panel).val() + "\n" + stopOption + textValue + ";");
					itemsChanged(true);
				});
			}
		},[":LS:|(Listing) Starts With", ":LC:|(Listing) Contains", ":LE:|(Listing) Ends With", ":RS:|(Rename) Starts With", ":RC:|(Rename) Contains", ":RE:|(Rename) Ends With", ":US:|(Upload) Starts With", ":UC:|(Upload) Contains", ":UE:|(Upload) Ends With", ":DS:|(Download) Starts With", ":DC:|(Download) Contains", ":DE:|(Download) Ends With"]);
		return false;
	});
}

panelRestrictions.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var xmlData = '<server_prefs type="properties">'+panelRestrictions.buildXMLData(_panel)+'</server_prefs>';
		common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", xmlData, function(data){
			data = $.xml2json(data, true);
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				common.data.updateLocalPrefs(function(){
					common.UI.hideIndicator();
					growl("Data saved", "Your changes are saved", false, 5000);
					placeHolder.removeData("hasChanged");
				});
			}
			else
			{
				growl("Error while saving", "Your changes are not saved", true);
			}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}

panelRestrictions.buildXMLData = function()
{
	var xmlString = buildXMLToSubmitForm(_panel);
	var day_of_week_allow = "";
	$("input.dayOfTheWeek:checked", _panel).each(function(){
		day_of_week_allow += $(this).attr("id").replace("day_of_week_allow_","");
	});
	xmlString += "\r\n<day_of_week_allow>" + day_of_week_allow + "</day_of_week_allow>";
	return xmlString;
}