/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelWebInterface = {};
panelWebInterface.localization = {};
/****************************/

// Panel details
var panelName = "WebInterface";
panelWebInterface._panel = $("#pnl" + panelName);

// Localizations
panelWebInterface.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelWebInterface.localization, localizations.panels[panelName]);

// Interface methods
panelWebInterface.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelWebInterface.bindData);
	panelWebInterface.bindEvents();
}

panelWebInterface.clearForm = function(panel)
{
	panel = panel || panelWebInterface._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			if($(this).closest("td").is(".checkboxArea"))return;
			userManager.UI.checkUnchekInput($(this));
		}
		else
		{
			$(this).val("");
		}
	});
}

panelWebInterface.bindData = function(userInfo, jsonDeep, panel)
{
	var dataPanel = panel || panelWebInterface._panel;
	panelWebInterface.clearForm(dataPanel);
	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);

		var webButtonsList = $("#buttonsList", dataPanel).empty();
		//Binding buttons
		userManager.UI.multiOptionControlDataBind(userInfo.user
			, "web_buttons"
			, webButtonsList
			, function(curItem){
					var key = unescape(curItem.key);
					return $("<li class='ui-widget-content' key='"+key+"'>"+ key +"</li>");
				}
			, !panel);

		//Binding Customizations
		var webCustomizationsDefaultControl = $("#webCustomizationsDefaultList", dataPanel);
		webCustomizationsDefaultControl.find("li:hidden").show();
		userManager.UI.multiOptionControlDataBind(userInfo.user
			, "web_customizations"
			, $("#webCustomizationsList", dataPanel).empty()
			, function(curItem){
					var key = curItem.key;
					var value = unescape(curItem.value);
					var keyText = key;
					var itemInDefaultList = webCustomizationsDefaultControl.find("li[key='"+key+"']");
					var htmlArea = false;
					if(itemInDefaultList.length>0)
					{
						keyText = itemInDefaultList.text();
						itemInDefaultList.hide();
					}
					return $("<li class='ui-widget-content' htmlArea='"+itemInDefaultList.attr("htmlArea")+"' headerText='"+keyText+"' key='"+key+"' selectedVal='"+userManager.methods.encode(value)+"'>"+ keyText + " : <span class='value'>" + (value) +"</span></li>");
				}
			, !panel
			, function(){
				webCustomizationsDefaultControl.find("li:hidden").show();
		});

		//Bind all form dropdown lists
		panelWebInterface.bindFormsDropdown($("select.formsField", dataPanel));

		//Method to set selection of custom forms
		function assignSelectedForm(list, value, flagAlways)
		{
			if(!value || !list)return;
			var dataInheritedFrom = false;
			var curData = userManager.methods.seperateValueAndInheritValue(value);
			value = curData.value;
			dataInheritedFrom = curData.inherit || dataInheritedFrom;
			value = unescape(value).split(":");
			if(value.length>0)
			{
				list.val(value[0]);
				if(flagAlways && value.length>2)
				{
					userManager.UI.checkUnchekInput(flagAlways, value[2] != "once");
				}
			}
			userManager.methods.showInheritValueLabel(list, dataInheritedFrom);
		}

		//Assign selected upload form
		assignSelectedForm($("#uploadForm", dataPanel), userInfo.user["uploadForm"]);
		//Assign selected welcome form
		assignSelectedForm($("#welcomeForm", dataPanel), userInfo.user["messageForm"], $("#showAlways", dataPanel));
		//Assign selected paste form
		assignSelectedForm($("#pasteForm", dataPanel), userInfo.user["pasteForm"]);

		if(!panel)
		{
			$("#uploadForm", dataPanel).closest("fieldset").removeClass("inheritSet");
			var fieldToUse = "uploadForm";
			if(typeof userManager.storage("currentUser").user["uploadForm"] == "undefined")
			{
				fieldToUse = "pasteForm";
				if(typeof userManager.storage("currentUser").user["pasteForm"] == "undefined")
				{
					fieldToUse = "welcomeForm";
				}
			}
			userManager.data.setInheritPropertyOfSection($("select.formsField:first", dataPanel), fieldToUse, true);
		}

		//Bind domains
		userManager.UI.multiOptionControlDataBind(userInfo.user
			, "domain_root_list"
			, $("#virtualDomainsList", dataPanel).empty()
			, function(curItem){
					var domain = unescape(curItem.domain);
					var path = unescape(curItem.path);
					return $("<li class='ui-widget-content'>"+ domain +" -> " + path + "</li>");
				}
		, !panel);

		//Post Bind Method
		userManager.UI.panelsPostbindEvent(dataPanel, panel);
	}
}

panelWebInterface.bindFormsDropdown = function(list)
{
	//Bind forms dropdown list
	if(!list)return;
	userManager.UI.multiOptionControlDataBind(userManager.storage("GUIXMLPrefs")
		, "CustomForms"
		, list
		, function(curItem){
				var id = curItem.id;
				var name = unescape(curItem.name);
				return $("<option value='"+ id +"'>"+ name + "</option>");
			}
	, false
	, function(){
		list.prepend("<option value=''></option>");
	});
}

panelWebInterface.bindEvents = function()
{
	//Toggle sections for this panel
	userManager.UI.togglePanels(panelWebInterface._panel);

	$(".checkboxArea>input[type='checkbox']", panelWebInterface._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelWebInterface.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	// Customization events
	var webCustomizationsDefaultControl = $("#webCustomizationsDefaultList", panelWebInterface._panel);
	var webCustomizationsList = $("#webCustomizationsList", panelWebInterface._panel);

	//Add customization
	$("a#addCustomization", panelWebInterface._panel).click(function(){
		var selected = webCustomizationsDefaultControl.find("li.ui-selected");
		if(selected.length>0)
		{
			var promptVal = selected.attr("key");
			var isColorBox = false;
			var isHTMLArea = false;
			if(promptVal.toLowerCase().indexOf("color")>=0)
			{
				promptVal = "Enter HTML color value for " + selected.text();
				isColorBox = true;
			}
			else
			{
				promptVal = selected.text();
			}
			if(selected.attr("htmlArea")=="true")
			{
				isHTMLArea = true;
			}
			jPrompt(promptVal + " : ", selected.attr("defaultVal"), "Input", function(value){
				if(value != null)
				{
					// Append selected option to list and hide from default list
					webCustomizationsList.append(selected.clone()
						.removeClass("ui-widget-header")
						.removeClass("ui-selected")
						.append(" : <span class='value'></span>")
						.attr("selectedVal", value)
						.attr("htmlArea", isHTMLArea)
						.attr("headerText", selected.text()));
					if(isHTMLArea) value = userManager.methods.decode(value);
					webCustomizationsList.find("li:last").find("span.value").text(value);
					selected.hide();
					panelWebInterface._panel.trigger("changed");
				}
			}
			, false
			, false
			, {isColorBox : isColorBox, isHTMLArea : isHTMLArea});
		}
		return false;
	});

	//Edit selected customization
	$("a#editCustomization", panelWebInterface._panel).click(function(){
		var selected = webCustomizationsList.find("li.ui-selected");
		if(selected.length>0)
		{
			var promptVal = selected.attr("key");
			var isColorBox = false;
			var isHTMLArea = false;
			if(promptVal.toLowerCase().indexOf("color")>=0)
			{
				promptVal = "Enter HTML color value for " + selected.attr("headerText");
				isColorBox = true;
			}
			else
			{
				promptVal = selected.attr("headerText");
			}
			var val = selected.attr("selectedVal");
			if(selected.attr("htmlArea")=="true")
			{
				isHTMLArea = true;
			}
			jPrompt(promptVal + " : ", val, "Input", function(value){
				if(value != null)
				{
					// Update data and value of selected option
					selected.attr("selectedVal", value);
					selected.find("span.value").text(value);
					panelWebInterface._panel.trigger("changed");
				}
			}
			, false
			, false
			, {isColorBox : isColorBox, isHTMLArea : isHTMLArea});
		}
		return false;
	});

	// Remove selected customization
	$("a#removeCustomization", panelWebInterface._panel).click(function(){
		// Remove from list and show in default list
		userManager.UI.removeItem(webCustomizationsList, function(focused, removed){
			var removedKey = $(removed).attr("key");
			webCustomizationsDefaultControl.find("li[key='"+removedKey+"']").show();
			panelWebInterface._panel.trigger("changed");
		}, true);
		return false;
	});

	// Button events
	var webButtonsList = $("#buttonsList", panelWebInterface._panel);

	// Move button up/down
	$("a#moveUpMenuItem, a#moveDownMenuItem", panelWebInterface._panel).click(function(){
		if(webButtonsList.find("li.ui-selected").length>0)
		{
			userManager.UI.moveItem(webButtonsList.find("li.ui-selected"), $(this).is("#moveUpMenuItem"), true);
			panelWebInterface._panel.trigger("changed");
		}
		return false;
	});

	//Remove selected button
	$("a#removeMenuItem", panelWebInterface._panel).click(function(){
		userManager.UI.removeItem(webButtonsList, function(){
			panelWebInterface._panel.trigger("changed");
		});
		return false;
	});

	//Add new button
	$("a#addMenuItem", panelWebInterface._panel).click(function(){
		jPrompt("Choose a button : ", "", "Buttons", function(command, key){
			if(command != null)
			{
				var data = command.split("::::");
				var privs = data[0];
				command = data[1];
				var buttonName = key;
				function enterButtonName()
				{
					jPrompt("Enter a name for this button : ", buttonName, "Button Name", function(value){
						if(value != null)
						{
							buttonName = value;
							function enterCommand()
							{
								jPrompt("In general you should leave this value as its default. <br> Enter the 'href' target for this button : ", command, "Target", function(value){
									if(value != null)
									{
										userManager.UI.addItem(webButtonsList
											, $("<li class='ui-widget-content' key='"+privs + ":" + buttonName+"'>" + privs + ":" + buttonName + "</li>")
											, {
												key : privs + ":" + buttonName,
												for_menu : true,
												requiredPriv : privs,
												value : value,
												for_context_menu :true
										});
										panelWebInterface.buttonSelected(webButtonsList, webButtonsList.find(".ui-widget-header"));
										panelWebInterface._panel.trigger("changed");
									}
								});
							}
							enterCommand();
						}
					});
				}
				enterButtonName();
			}
		}, ['(delete)::::javascript:performAction("delete");|Delete'
				, '(rename)::::javascript:performAction("rename");|Rename'
				, '(download)::::javascript:performAction("download");|Download'
				, '(download)::::javascript:performAction("quickAdvancedDownload");|Advanced Download'
				, '(zip)::::javascript:performAction("zip");|ZipDownload'
				, '(unzip)::::javascript:performAction("unzip");|Unzip'
				, '(zipItems)::::javascript:performAction("zipItems");|Zip Selected'
				, '(mkdir)::::javascript:performAction("createFolderDiv");|Create Folder'
				, '(upload)::::javascript:performAction("upload");|Upload'
				, '(search)::::javascript:performAction("searchDiv");|Search'
				, '(options)::::javascript:performAction("userOptions");|User Options'
				, '(cut)::::javascript:performAction("cut");|Cut'
				, '(copy)::::javascript:performAction("copy");|Copy'
				, '(paste)::::javascript:performAction("paste");|Paste'
				, '(slideshow)::::javascript:performAction("slideshow");|Slideshow'
				, '(slideshow)::::javascript:performAction("quickView");|QuickView'
				, '(slideshow)::::javascript:performAction("downloadLowRes");|Download Low-Res'
				, '(slideshow)::::javascript:performAction("Preview");|Preview'
				, '(view)::::javascript:performAction("batchComplete");|BatchComplete'
				, '(share)::::javascript:performAction("share");|Share'
				, '(share)::::javascript:performAction("manageShares");|Manage Shares'
				, '(showbasket)::::javascript:performAction("showBasket");|Show Basket'
				, '(addbasket)::::javascript:performAction("addToBasket");|Add To Basket'
				, '(updateKeywords)::::javascript:performAction("updateKeywords");|Edit Keywords'
				, '(changeIcon)::::javascript:performAction("changeIcon");|Change Icon'
				, '(custom)::::/WebInterface/help/index.html|Help'
				, '(login)::::/WebInterface/login.html|Login'
				, '(logout)::::javascript:doLogout();|Logout'
				, '(custom)::::(url,file, or javascript)|Custom'], 8);
		return false;
	});

	//Edit selected button
	$("a#editMenuItem", panelWebInterface._panel).click(function(){
		var selected = webButtonsList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			var controlData = selected.data("controlData");
			var key = unescape(controlData.key);
			if(key)
			{
				key = key.split(":");
			}
			var buttonName = $.trim(key[1]);
			var privs = $.trim(key[0]);
			jPrompt("Enter a name for this button : ", buttonName, "Button Name", function(value){
				if(value != null)
				{
					buttonName = value;
					function enterCommand()
					{
						var command = unescape(controlData.value);
						jPrompt("In general you should leave this value as its default. <br> Enter the 'href' target for this button : ", command, "Target", function(value){
							if(value != null)
							{
								userManager.UI.replaceItem(selected
									, $("<li class='ui-widget-content' key='"+privs + ":" + buttonName+"'>" + privs + ":" + buttonName + "</li>")
									, {
										key : privs + ":" + buttonName,
										for_menu : controlData.for_menu,
										requiredPriv : privs,
										value : value,
										for_context_menu  : controlData.for_context_menu
									}
									, function(){
										panelWebInterface._panel.trigger("changed");
								});
							}
						});
					}
					enterCommand();
				}
			});
		}
		return false;
	});

	//Bind on select of button from list
	webButtonsList.unbind("onSelect").bind("onSelect"
			, function(evt, list, selected){
				panelWebInterface.buttonSelected(list, selected);
	});

	//Change data of selected button when option changes
	var buttonsPanel = $("#buttonsPanel", panelWebInterface._panel);
	$("#buttonOnMenuBar, #buttonOnContextMenu", buttonsPanel).change(function(){
		var selected = webButtonsList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			var controlData = selected.data("controlData");
			if($(this).is(":checked"))
			{
				if($(this).is("#buttonOnMenuBar"))
				{
					controlData.for_menu = "true";
				}
				else if($(this).is("#buttonOnContextMenu"))
				{
					controlData.for_context_menu = "true";
				}
			}
			else
			{
				if($(this).is("#buttonOnMenuBar"))
				{
					controlData.for_menu = "false";
				}
				else if($(this).is("#buttonOnContextMenu"))
				{
					controlData.for_context_menu = "false";
				}
			}
			selected.data("controlData", controlData);
			panelWebInterface._panel.trigger("changed");
		}
		else
		{
			userManager.UI.checkUnchekInput($("#buttonOnMenuBar", buttonsPanel), false);
			userManager.UI.checkUnchekInput($("#buttonOnContextMenu", buttonsPanel), false);
		}
	});

	// Virtual Domain events
	var virtualDomainsList = $("#virtualDomainsList", panelWebInterface._panel);
	// Move domain up/down
	$("a#moveUpDomain, a#moveDownDomain", panelWebInterface._panel).click(function(){
		if(virtualDomainsList.find("li.ui-selected").length>0)
		{
			userManager.UI.moveItem(virtualDomainsList.find("li.ui-selected"), $(this).is("#moveUpDomain"), true);
			panelWebInterface._panel.trigger("changed");
		}
		return false;
	});

	//Remove selected domain
	$("a#deleteDomain", panelWebInterface._panel).click(function(){
		userManager.UI.removeItem(virtualDomainsList, function(){
			panelWebInterface._panel.trigger("changed");
		});
		return false;
	});

	//Add/Edit selected domain
	$("a#addDomain", panelWebInterface._panel).click(function(evt, control){
		var domain =  "";
		var path =  "";
		if(control && control.length>0 && control.data)
		{
			var controlData = control.data("controlData");
			domain = controlData.domain;
			path = controlData.path;
		}
		jPrompt("Please enter the domain. (Pattern matching is allowed such as *.domain.com) : ", domain, "Input", function(domain){
			if(domain != null)
			{
				if(domain.length == 0)
				{
					jAlert("Please enter domain", "Message"
					, function(){
						$("a#addDomain", panelWebInterface._panel).trigger("click", [control]);
					});
					return;
				}
				function enterPath()
				{
					jPrompt("Please enter the root folder for this domain in this user's VFS : <br />Example : /CrushFTP_Root/", path, "Input", function(path){
						if(path != null)
						{
							if(path.length == 0)
							{
								jAlert("Please enter path", "Message"
								, function(){
									enterPath();
								});
								return;
							}
							if(control) // If edit mode
							{
								userManager.UI.addItem(virtualDomainsList
									, $("<li class='ui-widget-content'>"+ domain +" -> " + path + "</li>")
									, {
										domain : domain,
										path : path
								}, function(newControl){
									control.replaceWith(newControl); // Append to list and replace selected with new item
								});
							}
							else // If add mode
							{
								userManager.UI.addItem(virtualDomainsList
									, $("<li class='ui-widget-content'>"+ domain +" -> " + path + "</li>")
									, {
										domain : domain,
										path : path
								});
							}
							panelWebInterface._panel.trigger("changed");
						}
					});
				}
				enterPath();
			}
		});
		return false;
	});

	//Event to edit domain
	$("a#editDomain", panelWebInterface._panel).click(function(){
		var selected = virtualDomainsList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			$("a#addDomain", panelWebInterface._panel).trigger("click", [selected]);
		}
		return false;
	});
}

// Event on button select
panelWebInterface.buttonSelected = function(list, selected)
{
	var buttonsPanel = $("#buttonsPanel", panelWebInterface._panel);
	var for_menu = "";
	var for_context_menu = "";
	if(selected) // If button is selected
	{
		// Options for selected button
		var controlData = selected.data("controlData");
		if(controlData)
		{
			if(controlData.for_menu)
				for_menu = controlData.for_menu.toString().toLowerCase();
			if(controlData.for_context_menu)
				for_context_menu = controlData.for_context_menu.toString().toLowerCase();
		}
	}
	userManager.UI.checkUnchekInput($("#buttonOnMenuBar", buttonsPanel), for_menu == "true");
	userManager.UI.checkUnchekInput($("#buttonOnContextMenu", buttonsPanel), for_context_menu == "true");
}

panelWebInterface.generateXML = function()
{
	var xml = "";

	//General items
	panelWebInterface._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	//Web customization
	if(panelWebInterface._panel.find("#webCustomizationsCheck").find("input:checked").length>0)
	{
		xml += "\r\n<web_customizations type=\"vector\">";
		var webCustomizationsList = $("#webCustomizationsList", panelWebInterface._panel);
		webCustomizationsList.find("li").each(function(){
			if($(this))
			{
				xml += "\r\n<web_customizations_subitem type=\"properties\">";
				xml += "\r\n<key>"+$(this).attr("key")+"</key>";
				xml += "\r\n<value>"+userManager.methods.htmlEncode($(this).attr("selectedVal"))+"</value>";
				xml += "\r\n</web_customizations_subitem>";
			}
		});
		xml += "\r\n</web_customizations>";
	}

	//Custom Forms
	if(panelWebInterface._panel.find("#webFormsCheck").find("input:checked").length>0)
	{
		$("select.formsField", panelWebInterface._panel).each(function(){
			var selectedVal = $(this).val();
			var tag = $(this).attr("id");
			if(selectedVal && selectedVal.length>0)
			{
				var formName = $(this).find(":selected").text() || "";
				var isAlways = "";
				if(tag == "welcomeForm")
				{
					tag = "messageForm";
					if($("#showAlways", panelWebInterface._panel).is(":checked"))
					{
						isAlways = ":always";
					}
					else
					{
						isAlways = ":once";
					}
				}
				selectedVal = selectedVal || "";
				isAlways = isAlways || "";
				xml += "\r\n<"+ tag + ">" + selectedVal + ":" + formName + isAlways + "</"+ tag + ">";
			}
			else
			{
				if(tag == "welcomeForm")
				{
					tag = "messageForm";
				}
				xml += "\r\n<"+ tag + "></"+ tag + ">";
			}
		});
	}

	//Web buttons
	if(panelWebInterface._panel.find("#webButtonsCheck").find("input:checked").length>0)
	{
		xml += "\r\n<web_buttons type=\"vector\">";
		var webButtonsList = $("#buttonsList", panelWebInterface._panel);
		webButtonsList.find("li").each(function(){
			var buttonData = $(this).data("controlData");
			if(buttonData)
			{
				xml += "\r\n<web_buttons_subitem type=\"properties\">";
				xml += "\r\n<key>"+buttonData.key+"</key>";
				xml += "\r\n<for_menu>"+buttonData.for_menu+"</for_menu>";
				xml += "\r\n<requiredPriv>"+buttonData.requiredPriv+"</requiredPriv>";
				xml += "\r\n<value>"+userManager.methods.htmlEncode(buttonData.value)+"</value>";
				xml += "\r\n<for_context_menu>"+buttonData.for_context_menu+"</for_context_menu>";
				xml += "\r\n</web_buttons_subitem>";
			}
		});
		xml += "\r\n</web_buttons>";
	}

	//Virtual domains root
	if(panelWebInterface._panel.find("#domainRootListCheck").find("input:checked").length>0)
	{
		xml += "\r\n<domain_root_list type=\"vector\">";
		var virtualDomainsList = $("#virtualDomainsList", panelWebInterface._panel);
		virtualDomainsList.find("li").each(function(){
			var domainData = $(this).data("controlData");
			if(domainData)
			{
				xml += "\r\n<domain_root_list_subitem type=\"properties\">";
				xml += "\r\n<path>"+userManager.methods.htmlEncode(domainData.path)+"</path>";
				xml += "\r\n<domain>"+userManager.methods.htmlEncode(domainData.domain)+"</domain>";
				xml += "\r\n</domain_root_list_subitem>";
			}
		});
		xml += "\r\n</domain_root_list>";
	}
	return xml;
}