/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelReportsSetup = {};
panelReportsSetup.localization = {};
/****************************/

// Panel details
panelReportsSetup.panelName = "ReportsSetup";
panelReportsSetup._panel = $("#pnl" + panelReportsSetup.panelName);

// Localizations
panelReportsSetup.localization = {
};

// Assign localizations
localizations.panels[panelReportsSetup.panelName] = $.extend(panelReportsSetup.localization, localizations.panels[panelReportsSetup.panelName]);

// Interface methods
panelReportsSetup.init = function(){
	applyLocalizations(panelReportsSetup.panelName, localizations.panels);
	$("#reportConfiguration", panelReportsSetup._panel).hide();
	panelReportsSetup.bindEvents();
	panelReportsSetup.bindData();
}

panelReportsSetup.bindData = function()
{
	var dates = $("#startDate, #endDate", panelReportsSetup._panel).datepicker({
		changeMonth: true,
		changeYear: true,
		onSelect: function(selectedDate) {
			var option = this.id == "startDate" ? "minDate" : "maxDate",
				instance = $(this).data("datepicker"),
				date = $.datepicker.parseDate(
					instance.settings.dateFormat ||
					$.datepicker._defaults.dateFormat,
					selectedDate, instance.settings );
			dates.not(this).datepicker("option", option, date);
		}
	});
	panelReportsSetup.bindForms();
	panelReportsSetup._panel.find("input#showFiles_1").trigger("change");
}

panelReportsSetup.bindEvents = function()
{
	panelReportsSetup._panel.find("#dateRange").change(function(){
		var range = $(this).val();
		if(range != "")
		{
			var days = parseInt(range);
            var startDate = new Date();
            startDate.setDate(startDate.getDate() - days);
            startDate = startDate.format("mm/dd/yyyy");

			$("#startDate", panelReportsSetup._panel).val(startDate).attr("disabled", true).addClass("ui-priority-secondary");
			$("#endDate", panelReportsSetup._panel).val("").attr("disabled", true).addClass("ui-priority-secondary");
        }
		else
		{
			var curDate = $("#startDate", panelReportsSetup._panel).val();
			if(curDate.length==0)
			{
				curDate = new Date();
				curDate.setDate(curDate.getDate()-14);
				curDate = curDate.format("mm/dd/yyyy");
			}
			$("#startDate", panelReportsSetup._panel).val(curDate).removeAttr("disabled").removeClass("ui-priority-secondary");
			$("#endDate", panelReportsSetup._panel).removeAttr("disabled").removeClass("ui-priority-secondary");
		}
	}).trigger("change");

	panelReportsSetup._panel.find("a#pickUsers").click(function(){
		$("#usernames", panelReportsSetup._panel).crushFtpPickUserPopup();
		return false;
	});

	panelReportsSetup._panel.find("input#showFiles_1").change(function(){
		if($(this).is(":checked"))
			panelReportsSetup._panel.find("p#sub_options_for_files").show();
		else
			panelReportsSetup._panel.find("p#sub_options_for_files").hide();
	});

	panelReportsSetup._panel.find("#reportName").change(function(){
		var reportConfiguration = $("#reportConfiguration", panelReportsSetup._panel);
		reportConfiguration.hide().find("div.reportConfig").hide();
		if($(this).val() && $(this).val() != "")
		{
			reportConfiguration.show().find("div#reportConfig" + $(this).val()).show();
		}
	});

	$("#reportDialog").dialog({
	   autoOpen: false,
	   modal: true,
	   height: 600,
	   width: 900,
	   show: "scale",
	   closeOnEscape : false,
		buttons: [
		{
			text: "Ok",
			click: function() { $(this).dialog("close"); }
		},
		{
			text: "Save Report",
			click: function() {
				$(this).dialog("close");
				panelReportsSetup._panel.find("#saveReport").trigger("click");
			}
		}]
     });

	panelReportsSetup._panel.find("#runReport, #saveReport").unbind().click(function(){
		if(panelReportsSetup._panel.find("#reportName").val() == "" || panelReportsSetup._panel.find("#reportName").val() == null)
		{
			jAlert("Please choose report to run", "Message", function(){
				panelReportsSetup._panel.find("#reportName").focus().select();
			});
			return false;
		}
		var params = panelReportsSetup.serializeReportElements();
		var parameters = params.join("&");
		if($(this).is("#saveReport"))
		{
			parameters += "&saveReport=true";
			$("#reportDialog").html('<iframe id="reportDialogFrame" width="99%" height="99%" marginWidth="0" marginHeight="0" frameBorder="0" scrolling="auto" />');
			$("#reportDialogFrame").attr("src", "/WebInterface/function/?command=runReport&" + parameters);
		}
		else
		{
			var startDate = $("#startDate", panelReportsSetup._panel).val();
			var endDate = $("#endDate", panelReportsSetup._panel).val();
			endDate = endDate.length>0 ? endDate : "Present Day"
			var title = "Report : " + panelReportsSetup._panel.find("#reportName").find(":selected").text() + " <small style='position:absolute;top:3px;right:35px;'>(Between " + startDate +" to "+ endDate + ")</small>";
			$("#reportDialog").html('<iframe id="reportDialogFrame" onload="panelReportsSetup.reportFrameLoaded();" width="99%" height="99%" marginWidth="0" marginHeight="0" frameBorder="0" scrolling="auto" />').dialog( "option", "title", title).dialog("open");
			setTimeout(function(){
				$("#reportDialogFrame").attr("src", "/WebInterface/function/?command=runReport&" + parameters);
			}, 500);
			$("#reportDialog").block({
				message:  '<div>Loading...</div>',
				css: {
					border: 'none',
					padding: '15px',
					backgroundColor: '#000',
					'-webkit-border-radius': '10px',
					'-moz-border-radius': '10px',
					opacity: .5,
					color: '#fff',
					width:'100%',
					'text-align':'center'
				}
			});
		}
		return false;
	});
};

panelReportsSetup.serializeReportElements = function(delimiter)
{
	function elemName(name)
	{
		if(name == "linked_vfs_users") return name;
		if(name.indexOf("_")>=0)
		{
			name = name.substr(0, name.indexOf("_"));
		}
		return name;
	}
	var params = [];
	delimiter = delimiter || "=";
	var isDateRange = panelReportsSetup._panel.find("#dateRange").val() != "";
	panelReportsSetup._panel.find("#reportInputs").find(".reportElement").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			params.push($(this).attr("id") + delimiter + $(this).is(":checked"));
		}
		else
		{
			var id = $(this).attr("id");
			params.push($(this).attr("id") + delimiter + $(this).val());
		}
	});

	var reportName = panelReportsSetup._panel.find("#reportName").val();
	panelReportsSetup._panel.find("div#reportConfig" + reportName).find(".reportElement").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			params.push(elemName($(this).attr("id")) + delimiter + $(this).is(":checked"));
		}
		else
		{
			params.push(elemName($(this).attr("id")) + delimiter + $(this).val());
		}
	});
	if(isDateRange)
	{
		params.push("show" + delimiter + panelReportsSetup._panel.find("#dateRange").find(":selected").text());
	}
	return params;
}

panelReportsSetup.reportFrameLoaded = function()
{
	$("#reportDialog").unblock();
};

panelReportsSetup.bindScheduleConfig = function(config)
{
	$("#reportsPanelTabs").tabs({selected:0});
	if(config)
	{
		panelReportsSetup._panel.clearForm();
		adminPanel.data.bindValuesFromJson(panelReportsSetup._panel, config, false, true);
		if(config.show)
		{
			panelReportsSetup._panel.find("#dateRange option:contains(" + config.show + ")").attr('selected', 'selected').trigger("change");
		}
	}
	return false;
}

panelReportsSetup.bindForms = function()
{
	var formsDropdowns = $("#uploadForm,#welcomeForm", panelReportsSetup._panel).empty();
	var prefs = adminPanel.storage("GUIXMLPrefs");
	var forms = prefs.CustomForms;
	adminPanel.methods.rebuildSubItems(forms, "CustomForms");
	if(forms && forms.CustomForms_subitem)
	{
		forms = forms.CustomForms_subitem;
	}
	formsDropdowns.append("<option value=''></option>");
	if(forms && forms.length>0)
	{
		for(var i=0;i<forms.length;i++)
		{
			var curForm = forms[i];
			if(curForm)
			{
				formsDropdowns.append("<option value='"+curForm.id+"'>"+curForm.name+"</option>");
			}
		}
	}
}